﻿Public Class ErrorLogging

    Private ErrorLog As Generic.List(Of String)
    Private HasErrorLog As Boolean

    Public ReadOnly Property HasError As Boolean
        Get
            Return HasErrorLog
        End Get
    End Property

    Public Sub New()
        ErrorLog = New Generic.List(Of String)
    End Sub

    Public Sub AddLogMessage(ByVal message As String)
        ErrorLog.Add(message)
        HasErrorLog = True
    End Sub

    Public Function GetLogMessage() As String
        Dim logMessage As String = ""
        For Each log As String In ErrorLog
            logMessage = logMessage & log & vbCrLf
        Next
        logMessage = logMessage.TrimEnd(vbCrLf)
        Return logMessage
    End Function

    Public Sub ClearLog()
        ErrorLog.Clear()
        HasErrorLog = False
    End Sub

    Sub AddLogMessage(ByVal message As String, ByVal errorcode As String, ByVal errormessage As String)
        message = String.Format(message, errorcode, errormessage)
        ErrorLog.Add(message)
        HasErrorLog = True
    End Sub

End Class
