﻿Public Class SettingsController

    <Serializable()> _
    Private Class Settings
        Implements ISettings


        Private _amazonS3AccessKey As String
        Private _amazonS3Prefix As String
        Private _amazonS3SecretKey As String
        Private _amazonS3DefaultBucket As String
        Private _connectionTimeout As UInteger
        Private _proxyActive As Boolean
        Private _proxyHost As String
        Private _proxyPort As UInteger

        Public Property AmazonS3AccessKey As String Implements ISettings.AmazonS3AccessKey
            Get
                Return _amazonS3AccessKey
            End Get
            Set(ByVal value As String)
                _amazonS3AccessKey = value
            End Set
        End Property

        Public Property AmazonS3Prefix As String Implements ISettings.AmazonS3Prefix
            Get
                Return _amazonS3Prefix
            End Get
            Set(ByVal value As String)
                _amazonS3Prefix = value
            End Set
        End Property

        Public Property AmazonS3SecretKey As String Implements ISettings.AmazonS3SecretKey
            Get
                Return _amazonS3SecretKey
            End Get
            Set(ByVal value As String)
                _amazonS3SecretKey = value
            End Set
        End Property

        Public Property ConnectionTimeout As UInteger Implements ISettings.ConnectionTimeout
            Get
                Return _connectionTimeout
            End Get
            Set(ByVal value As UInteger)
                _connectionTimeout = value
            End Set
        End Property

        Public Property ProxyActive As Boolean Implements ISettings.ProxyActive
            Get
                Return _proxyActive
            End Get
            Set(ByVal value As Boolean)
                _proxyActive = value
            End Set
        End Property

        Public Property ProxyHost As String Implements ISettings.ProxyHost
            Get
                Return _proxyHost
            End Get
            Set(ByVal value As String)
                _proxyHost = value
            End Set
        End Property

        Public Property ProxyPort As UInteger Implements ISettings.ProxyPort
            Get
                Return _proxyPort
            End Get
            Set(ByVal value As UInteger)
                _proxyPort = value
            End Set
        End Property

        Public Property AmazonS3DefaultBucket As String Implements ISettings.AmazonS3DefaultBucket
            Get
                Return _amazonS3DefaultBucket
            End Get
            Set(ByVal value As String)
                _amazonS3DefaultBucket = value
            End Set
        End Property
    End Class

    Public Shared Sub SaveSettings(ByVal settingsInterface As ISettings)
        Dim settingsObject As New Settings
        settingsObject.AmazonS3AccessKey = settingsInterface.AmazonS3AccessKey
        settingsObject.AmazonS3Prefix = settingsInterface.AmazonS3Prefix
        settingsObject.AmazonS3SecretKey = settingsInterface.AmazonS3SecretKey
        settingsObject.ProxyActive = settingsInterface.ProxyActive
        settingsObject.ProxyHost = settingsInterface.ProxyHost
        settingsObject.ProxyPort = settingsInterface.ProxyPort
        settingsObject.ConnectionTimeout = settingsInterface.ConnectionTimeout
        settingsObject.AmazonS3DefaultBucket = settingsInterface.AmazonS3DefaultBucket

        Dim formatter As Runtime.Serialization.IFormatter = New Runtime.Serialization.Formatters.Binary.BinaryFormatter()
        Dim stream As IO.Stream = New System.IO.FileStream("settings.bin", System.IO.FileMode.Create, System.IO.FileAccess.Write, System.IO.FileShare.None)
        formatter.Serialize(stream, settingsObject)
        stream.Close()
    End Sub

    Public Shared Sub LoadSettings(ByRef settingsInterface As ISettings)
        If System.IO.File.Exists("settings.bin") Then
            Dim formatter As Runtime.Serialization.IFormatter = New Runtime.Serialization.Formatters.Binary.BinaryFormatter()
            Dim stream As System.IO.Stream = New System.IO.FileStream("settings.bin", System.IO.FileMode.Open, System.IO.FileAccess.Read, System.IO.FileShare.Read)
            Dim settingsObject As Settings = CType(formatter.Deserialize(stream), Settings)
            stream.Close()

            settingsInterface.AmazonS3AccessKey = settingsObject.AmazonS3AccessKey
            settingsInterface.AmazonS3Prefix = settingsObject.AmazonS3Prefix
            settingsInterface.AmazonS3SecretKey = settingsObject.AmazonS3SecretKey
            settingsInterface.ProxyActive = settingsObject.ProxyActive
            settingsInterface.ProxyHost = settingsObject.ProxyHost
            settingsInterface.ProxyPort = settingsObject.ProxyPort
            settingsInterface.ConnectionTimeout = settingsObject.ConnectionTimeout
            settingsInterface.AmazonS3DefaultBucket = settingsObject.AmazonS3DefaultBucket
        End If
    End Sub

End Class
