﻿Public Class FormAS3Explorer
    Implements ISettings, IBucket, IUpload, IDownload

#Region "ISettings Implementation"
    Public Property AmazonS3AccessKey As String Implements ISettings.AmazonS3AccessKey
        Get
            Return Me.TextBoxAccessKey.Text
        End Get
        Set(ByVal value As String)
            Me.TextBoxAccessKey.Text = value
        End Set
    End Property

    Public Property AmazonS3Prefix As String Implements ISettings.AmazonS3Prefix
        Get
            Return Me.TextBoxPrefix.Text
        End Get
        Set(ByVal value As String)
            Me.TextBoxPrefix.Text = value
        End Set
    End Property

    Public Property AmazonS3SecretKey As String Implements ISettings.AmazonS3SecretKey
        Get
            Return Me.TextBoxSecretKey.Text
        End Get
        Set(ByVal value As String)
            Me.TextBoxSecretKey.Text = value
        End Set
    End Property

    Public Property ConnectionTimeout As UInteger Implements ISettings.ConnectionTimeout
        Get
            Return Me.NumericUpDownTimeout.Value
        End Get
        Set(ByVal value As UInteger)
            Me.NumericUpDownTimeout.Value = value
        End Set
    End Property

    Public Property ProxyActive As Boolean Implements ISettings.ProxyActive
        Get
            Return Me.RadioButtonProxy.Checked
        End Get
        Set(ByVal value As Boolean)
            Me.RadioButtonProxy.Checked = value
        End Set
    End Property

    Public Property ProxyHost As String Implements ISettings.ProxyHost
        Get
            Return Me.TextBoxHost.Text
        End Get
        Set(ByVal value As String)
            Me.TextBoxHost.Text = value
        End Set
    End Property

    Public Property ProxyPort As UInteger Implements ISettings.ProxyPort
        Get
            Return Me.NumericUpDownPort.Value
        End Get
        Set(ByVal value As UInteger)
            Me.NumericUpDownPort.Value = value
        End Set
    End Property

    Public Property AmazonS3DefaultBucket As String Implements ISettings.AmazonS3DefaultBucket
        Get
            Return Me.TextBoxDefaultBucket.Text
        End Get
        Set(ByVal value As String)
            Me.TextBoxDefaultBucket.Text = value
        End Set
    End Property
#End Region

#Region "IBucket Implementation"
    Public ReadOnly Property BucketName As String Implements IBucket.BucketName, IUpload.BucketName, IDownload.BucketName
        Get
            Dim _bucketName As String
            If TypeOf ComboBoxBucket.SelectedItem Is Amazon.S3.Model.S3Bucket Then
                _bucketName = CType(ComboBoxBucket.SelectedItem, Amazon.S3.Model.S3Bucket).BucketName
            ElseIf Not ComboBoxBucket.SelectedItem Is Nothing Then
                _bucketName = ComboBoxBucket.SelectedItem.ToString
            ElseIf ComboBoxBucket.Text <> "" Then
                _bucketName = ComboBoxBucket.Text
            Else
                _bucketName = ""
            End If
            Return _bucketName
        End Get
    End Property

    Public ReadOnly Property NewBucketLocation As Amazon.S3.Model.S3Region Implements IBucket.NewBucketLocation
        Get
            Dim newLocation As Amazon.S3.Model.S3Region = Nothing
            If RadioButtonUS.Checked Then
                newLocation = Amazon.S3.Model.S3Region.US
            ElseIf RadioButtonEU.Checked Then
                newLocation = Amazon.S3.Model.S3Region.EU
            ElseIf RadioButtonUSWEST.Checked Then
                newLocation = Amazon.S3.Model.S3Region.SFO
            ElseIf RadioButtonAPAC.Checked Then
                newLocation = Amazon.S3.Model.S3Region.APN1
            End If
            Return newLocation
        End Get
    End Property

    Public ReadOnly Property NewBucketName As String Implements IBucket.NewBucketName
        Get
            Return Me.TextBoxNewBucket.Text
        End Get
    End Property

    Public ReadOnly Property NewBucketLocationExist As Boolean Implements IBucket.NewBucketLocationExist
        Get
            Dim locationExist As Boolean = False
            If RadioButtonUS.Checked Then
                locationExist = True
            ElseIf RadioButtonEU.Checked Then
                locationExist = True
            ElseIf RadioButtonUSWEST.Checked Then
                locationExist = True
            ElseIf RadioButtonAPAC.Checked Then
                locationExist = True
            End If
            Return locationExist
        End Get
    End Property
#End Region

#Region "IUpload Implementation"
    Public WriteOnly Property UploadedBytes As String Implements IUpload.UploadedBytes
        Set(ByVal value As String)
            Me.LabelUploadedValue.Text = value
        End Set
    End Property

    Public Property UploadFilePath As String Implements IUpload.UploadFilePath
        Get
            Return Me.TextBoxUpload.Text
        End Get
        Set(ByVal value As String)
            Me.TextBoxUpload.Text = value
        End Set
    End Property

    Public WriteOnly Property UploadFileSize As String Implements IUpload.UploadFileSize
        Set(ByVal value As String)
            Me.LabelUploadFileSizeValue.Text = value
        End Set
    End Property

    Public Property UploadStatus As String Implements IUpload.UploadStatus
        Get
            Return Me.LabelUploadStatusValue.Text
        End Get
        Set(ByVal value As String)
            SetUploadStatus(value)
        End Set
    End Property

    Public WriteOnly Property UploadTime As String Implements IUpload.UploadTime
        Set(ByVal value As String)
            Me.LabelUploadTimeValue.Text = value
        End Set
    End Property

    Public ReadOnly Property KeyName As String Implements IUpload.KeyName
        Get
            Dim filePath As String = Me.UploadFilePath
            Return filePath.Replace("\", "/")
        End Get
    End Property

#End Region

#Region "IDownload Implementation"
    Public ReadOnly Property DownloadKeyName As String Implements IDownload.DownloadKeyName
        Get
            Return TreeViewObjects.SelectedNode.Tag
        End Get
    End Property
    Public Property DowloadFilePath As String Implements IDownload.DowloadFilePath
        Get
            Return Me.TextBoxDownloadLocation.Text
        End Get
        Set(ByVal value As String)
            Me.TextBoxDownloadLocation.Text = value
        End Set
    End Property

    Public WriteOnly Property DownloadedBytes As String Implements IDownload.DownloadedBytes
        Set(ByVal value As String)
            Me.LabelDownloadedValue.Text = value
        End Set
    End Property

    Public WriteOnly Property DownloadFileSize As String Implements IDownload.DownloadFileSize
        Set(ByVal value As String)
            Me.LabelDownloadFileSizeValue.Text = value
        End Set
    End Property

    Public Property DownloadStatus As String Implements IDownload.DownloadStatus
        Get
            Return Me.LabelDownloadStatusValue.Text
        End Get
        Set(ByVal value As String)
            SetDownloadStatus(value)
        End Set
    End Property

    Public WriteOnly Property DownloadTime As String Implements IDownload.DownloadTime
        Set(ByVal value As String)
            Me.LabelDownloadTimeValue.Text = value
        End Set
    End Property
    Public ReadOnly Property DownloadFileName As String Implements IDownload.DownloadFileName
        Get
            Return TreeViewObjects.SelectedNode.Text
        End Get
    End Property
#End Region

    Private WithEvents AWS3 As AmazonS3Service = Nothing

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        AS3AboutBox.ShowDialog()
        AS3AboutBox.Dispose()
    End Sub

    Private Sub FormAS3Explorer_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim settings As ISettings = Me
        SettingsController.LoadSettings(settings)
        My.User.InitializeWithWindowsUser()
        If settings.AmazonS3AccessKey <> "" AndAlso settings.AmazonS3SecretKey <> "" AndAlso settings.AmazonS3Prefix <> "" Then
            TabControlMain.SelectedTab = TabPageBucket
            If settings.ProxyActive Then
                AWS3 = New AmazonS3Service(settings.AmazonS3AccessKey, settings.AmazonS3SecretKey, settings.AmazonS3Prefix, settings.ProxyHost, settings.ProxyPort)
            Else
                AWS3 = New AmazonS3Service(settings.AmazonS3AccessKey, settings.AmazonS3SecretKey, settings.AmazonS3Prefix)
            End If
        Else
            TabControlMain.SelectedTab = TabPageSetting
        End If

    End Sub

    Private Sub FormAS3Explorer_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        TabControlMain.Refresh()
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub ButtonApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonApply.Click
        Dim settings As ISettings = Me
        SettingsController.SaveSettings(settings)
        If Not AWS3 Is Nothing Then
            AWS3 = Nothing
            GC.Collect()
        End If
        If settings.ProxyActive Then
            AWS3 = New AmazonS3Service(settings.AmazonS3AccessKey, settings.AmazonS3SecretKey, settings.AmazonS3Prefix, settings.ProxyHost, settings.ProxyPort)
        Else
            AWS3 = New AmazonS3Service(settings.AmazonS3AccessKey, settings.AmazonS3SecretKey, settings.AmazonS3Prefix)
        End If
        ComboBoxBucket.DisplayMember = "BucketName"
        ComboBoxBucket.DataSource = AWS3.GetBucketList()
        ComboBoxBucket.SelectedIndex = ComboBoxBucket.FindStringExact(settings.AmazonS3DefaultBucket)
    End Sub

    Private Sub FormAS3Explorer_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        If Not AWS3 Is Nothing Then
            Application.DoEvents()
            Me.Cursor = Cursors.WaitCursor
            Dim settings As ISettings = Me
            ComboBoxBucket.DisplayMember = "BucketName"
            ComboBoxBucket.DataSource = AWS3.GetBucketList()
            ComboBoxBucket.SelectedIndex = ComboBoxBucket.FindStringExact(settings.AmazonS3DefaultBucket)
            Me.Cursor = Cursors.Default
        End If
    End Sub

    Private Sub TabControlMain_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControlMain.SelectedIndexChanged
        If Not AWS3 Is Nothing Then
            Dim bucket As IBucket = Me
            If Me.TabControlMain.SelectedTab Is Me.TabPageDownload AndAlso TreeViewObjects.Nodes.Count = 0 Then

                If bucket.BucketName <> "" Then
                    Me.Cursor = Cursors.WaitCursor
                    Dim s3objects As Generic.List(Of Amazon.S3.Model.S3Object) = Nothing
                    Application.DoEvents()
                    Me.LabelDownloadStatusValue.Text = "Loading objects"
                    s3objects = AWS3.GetObjectList(bucket.BucketName)
                    Me.LabelDownloadStatusValue.Text = "Idel"
                    Application.DoEvents()
                    If Not s3objects Is Nothing Then
                        Dim keyTree As New KeyParsing
                        For Each s3object As Amazon.S3.Model.S3Object In s3objects
                            keyTree.AddKey(s3object.Key)
                        Next
                        keyTree.PopulateTreeView(Me.TreeViewObjects)
                    End If
                    Me.Cursor = Cursors.Default
                End If
            End If
        End If
    End Sub

    Private Sub ButtonRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRefresh.Click
        If Not AWS3 Is Nothing Then
            Dim bucket As IBucket = Me
            TreeViewObjects.Nodes.Clear()

            If bucket.BucketName <> "" Then
                Dim s3objects As Generic.List(Of Amazon.S3.Model.S3Object) = Nothing

                s3objects = AWS3.GetObjectList(bucket.BucketName)

                If Not s3objects Is Nothing Then
                    Dim keyTree As New KeyParsing
                    For Each s3object As Amazon.S3.Model.S3Object In s3objects
                        keyTree.AddKey(s3object.Key)
                    Next
                    keyTree.PopulateTreeView(Me.TreeViewObjects)
                End If
            End If
        End If
    End Sub

    Private Sub ComboBoxBucket_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBoxBucket.SelectedIndexChanged
        TreeViewObjects.Nodes.Clear()
    End Sub

    Private Sub ButtonCreateBucket_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCreateBucket.Click
        If Not AWS3 Is Nothing Then
            Dim bucket As IBucket = Me
            AWS3.CreateBucket(bucket)
        End If
    End Sub

    Private Sub ButtonDeleteBucket_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDeleteBucket.Click
        If Not AWS3 Is Nothing Then
            Dim bucket As IBucket = Me
            If MessageBox.Show("Do you really want to delete bucket " & bucket.BucketName & "?", "Delete Bucket", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
                AWS3.DeleteBucket(bucket)
            End If
        End If
    End Sub

    Private Sub ButtonBrowseUpload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonBrowseUpload.Click
        If OpenFileDialogUpload.ShowDialog = Windows.Forms.DialogResult.OK Then
            TextBoxUpload.Text = OpenFileDialogUpload.FileName
        End If
    End Sub

    Private Sub ButtonStartUpload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStartUpload.Click
        If Not AWS3 Is Nothing Then
            Dim upload As IUpload = Me
            ProgressBarUpload.Value = 0
            AWS3.UploadFile(upload)
            upload.UploadStatus = "Start upload"
        End If
    End Sub

    Private Delegate Sub delegate_UploadFileProgress(ByVal sender As Object, ByVal e As Amazon.S3.Transfer.UploadProgressArgs)
    Private Delegate Sub delegate_DownloadFileProgress(ByVal sender As Object, ByVal e As Amazon.S3.Model.WriteObjectProgressArgs)

    Private Sub AWS3_DownloadFileProgress(ByVal sender As Object, ByVal e As Amazon.S3.Model.WriteObjectProgressArgs) Handles AWS3.DownloadFileProgress
        If ProgressBarDownload.InvokeRequired Then
            Dim callback As New delegate_DownloadFileProgress(AddressOf AWS3_DownloadFileProgress)
            ProgressBarDownload.Invoke(callback, sender, e)
        Else
            ProgressBarDownload.Value = e.PercentDone
            Dim download As IDownload = Me
            download.DownloadedBytes = e.TransferredBytes
            download.DownloadFileSize = e.TotalBytes
            download.DownloadStatus = "Downloading"
        End If
    End Sub

    Private Sub AWS3_ObjectDeleted(ByVal download As IDownload) Handles AWS3.ObjectDeleted
        If Not TreeViewObjects.SelectedNode Is Nothing AndAlso TreeViewObjects.SelectedNode.Nodes.Count = 0 Then
            TreeViewObjects.SelectedNode.Remove()
        End If
    End Sub

    Private Sub AWS3_UploadFileProgress(ByVal sender As Object, ByVal e As Amazon.S3.Transfer.UploadProgressArgs) Handles AWS3.UploadFileProgress
        If ProgressBarUpload.InvokeRequired Then
            Dim callback As New delegate_UploadFileProgress(AddressOf AWS3_UploadFileProgress)
            ProgressBarUpload.Invoke(callback, sender, e)
        Else
            ProgressBarUpload.Value = e.PercentDone
            Dim upload As IUpload = Me
            upload.UploadedBytes = e.TransferredBytes
            upload.UploadFileSize = e.TotalBytes
            upload.UploadStatus = "Uploading"
        End If
    End Sub

    Private Delegate Sub delegate_SetUploadStatus(ByVal status As String)

    Private Sub SetUploadStatus(ByVal status As String)
        If Me.LabelUploadStatusValue.InvokeRequired Then
            Dim callback As New delegate_SetUploadStatus(AddressOf SetUploadStatus)
            Me.LabelUploadStatusValue.Invoke(callback, status)
        Else
            Me.LabelUploadStatusValue.Text = status
        End If
    End Sub

    Private Delegate Sub delegate_SetDownloadStatus(ByVal status As String)

    Private Sub SetDownloadStatus(ByVal status As String)
        If Me.LabelDownloadStatusValue.InvokeRequired Then
            Dim callback As New delegate_SetDownloadStatus(AddressOf SetDownloadStatus)
            Me.LabelDownloadStatusValue.Invoke(callback, status)
        Else
            Me.LabelDownloadStatusValue.Text = status
        End If
    End Sub

    Private Sub ButtonDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDelete.Click
        If Not TreeViewObjects.SelectedNode Is Nothing AndAlso TreeViewObjects.SelectedNode.Nodes.Count = 0 Then
            If Not AWS3 Is Nothing Then
                Dim download As IDownload = Me
                If MessageBox.Show("Do you really want to delete file " & download.DownloadFileName & "?", "Delete Object", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
                    AWS3.DeleteObject(download)
                End If
            End If
        End If
    End Sub

    Private Sub ButtonBrowseDownload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonBrowseDownload.Click
        If FolderBrowserDialogDownload.ShowDialog = Windows.Forms.DialogResult.OK Then
            TextBoxDownloadLocation.Text = FolderBrowserDialogDownload.SelectedPath
        End If
    End Sub

    Private Sub ButtonDownload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDownload.Click
        If Not TreeViewObjects.SelectedNode Is Nothing AndAlso TreeViewObjects.SelectedNode.Nodes.Count = 0 Then
            If TextBoxDownloadLocation.Text = "" Then
                If FolderBrowserDialogDownload.ShowDialog = Windows.Forms.DialogResult.OK Then
                    TextBoxDownloadLocation.Text = FolderBrowserDialogDownload.SelectedPath
                End If
            End If
            If Not AWS3 Is Nothing Then
                Dim download As IDownload = Me
                ProgressBarDownload.Value = 0
                AWS3.DownloadFile(download)
                download.DownloadStatus = "Start download"
            End If
        End If
    End Sub

    Private Sub UploadFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UploadFileToolStripMenuItem.Click
        TabControlMain.SelectedTab = Me.TabPageUpload
    End Sub

    Private Sub DownloadFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DownloadFileToolStripMenuItem.Click
        TabControlMain.SelectedTab = Me.TabPageDownload
    End Sub

    Private Sub DeleteFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteFileToolStripMenuItem.Click
        TabControlMain.SelectedTab = Me.TabPageDownload
    End Sub

    Private Sub SettingsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SettingsToolStripMenuItem.Click
        TabControlMain.SelectedTab = Me.TabPageSetting
    End Sub

    Private Sub RadioButtonProxy_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonProxy.CheckedChanged
        TextBoxHost.Enabled = RadioButtonProxy.Checked
        NumericUpDownPort.Enabled = RadioButtonProxy.Checked
    End Sub
End Class
